#Asiri Tennakoon 2017 Sep
#Component Grid Clone

from vcCommand import *
from vcScript  import *
import vcVector
from math import *
from vcHelpers.Selection import *
from vcApplication import *

app = getApplication()
cmd = getCommand()
sim = app.getSimulation()

coord = createProperty(VC_STRING, 'Co-Ordinates',VC_PROPERTY_STEP)
coord.StepValues = ['World','Object']
coord.Value = 'World'
nx = createProperty(VC_INTEGER, 'X_Clones')
sx = createProperty(VC_REAL, 'X_Step')
ny = createProperty(VC_INTEGER, 'Y_Clones')
sy = createProperty(VC_REAL, 'Y_Step')
nz = createProperty(VC_INTEGER, 'Z_Clones')
sz = createProperty(VC_REAL, 'Z_Step')
cloneBtn = createProperty(VC_BUTTON, 'Clone')

for p in cmd.Properties:
  if p.Type == VC_REAL: p.Quantity = 'Distance'

def OnStart():
  cloneBtn.OnChanged = gridClone
  executeInActionPanel()
 

def gridClone(arg):
  comp = getSelectedComponents()[0]
  comps = [x for x in app.Components if comp.Name in x.Name if x.Name != comp.Name]
  for c in comps:
    print 'Deleting Component : ',c.Name
    c.delete()
  if nx.Value:
    for x in range (nx.Value):
      if x>0:
        newcomp = comp.clone()
        m = comp.PositionMatrix
        if coord.Value == 'World':
          m.translateAbs(float(sx.Value)*x,0,0)
        if coord.Value == 'Object':
          m.translateRel(float(sx.Value)*x,0,0)
        newcomp.PositionMatrix = m
  else: print 'Please Enter a Valid Input for X_Step'
  #app.render()
  newcomps = [x for x in app.Components  if comp.Name in x.Name]
  if ny.Value:
    for y in range(ny.Value):
      if y>0:
        for num,c in enumerate(newcomps):
          newcomp = c.clone()
          m = c.PositionMatrix
          if coord.Value == 'World':          
            m.translateAbs(0,(sy.Value)*y,0)
          if coord.Value == 'Object':
            m.translateRel(0,(sy.Value)*y,0)
          newcomp.PositionMatrix = m
  else: print 'Please Enter a Valid Input for Y_Step'
  #app.render()
  newcomps = [x for x in app.Components  if comp.Name in x.Name]
  if nz.Value:
    for z in range(nz.Value):
      if z>0:
        for num,c in enumerate(newcomps):
          newcomp = c.clone()
          m = c.PositionMatrix
          if coord.Value == 'World':          
            m.translateAbs(0,0,(sz.Value)*z)
          if coord.Value == 'Object':
            m.translateRel(0,0,(sz.Value)*z)
          newcomp.PositionMatrix = m
      app.render()
  else: print 'Please Enter a Valid Input for Z_Step'
  sim.update()
  app.render()

addState( None )
